------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--                                                                                      --
--                          ||       ||   ||     ||||||||    |||                        --
--                         ||||      ||  ||            ||   ||||                        --
--                        ||  ||     || ||            ||   || ||                        --
--                       ||||||||    ||||            ||   |||||||                       --
--                      ||      ||   || ||          ||  	  ||                        --
--                     ||        ||  ||  ||        ||         ||                        --
--                    ||          || ||   ||      ||  	      ||                        --
--                                                                                      --
------------------------------------------------------------------------------------------
--																						--
--						  	 		   > [Functions]									--
--									   > [Arrays]		   								--
--									   > [Override]				    					--
--									   > [Adds] 										--
--									   > [Forbids] 										--
--									   > [Stance]										--
--									   > [Underbarrel] 							    	--
--									   > [Tweaks] 										--
--									   > [WIP] 											--
--																						--
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------


---------------------------------------------
----<A><K><7><4> -Functions- <A><K><7><4>----
---------------------------------------------

--- Forbid Setup ---
function WeaponFactoryTweakData:akpack_setup_forbid( mod_one, mod_two )
	if self.parts[mod_one] and self.parts[mod_two] then
		self.parts[mod_one].forbids = self.parts[mod_one].forbids or {}
		table.insert(self.parts[mod_one].forbids, mod_two)
		self.parts[mod_two].forbids = self.parts[mod_two].forbids or {}
		table.insert(self.parts[mod_two].forbids, mod_one)
	else
		if not self.parts[mod_one] then
			self:akpack_write_error( "forbid_setup", "fti", "part", mod_two )	
		end
		if not self.parts[mod_two] then
			self:akpack_write_error( "forbid_setup", "fti", "part", mod_two )	
		end
	end
end

--- Override Base ---
function WeaponFactoryTweakData:akpack_check_override( mod_type, mod_woa ) 
	if mod_type == "wpn" then
		if self[mod_woa] then
			self[mod_woa].override = self[mod_woa].override or {}
		else 
			self:akpack_write_error( "override_check", "fti", mod_type, mod_woa )
		end
	elseif mod_type == "part" then
		if self.parts[mod_woa] then
			self.parts[mod_woa].override = self.parts[mod_woa].override or {}
		else 
			self:akpack_write_error( "override_check", "fti", mod_type, mod_woa )
		end
	else
		self:akpack_write_error( "override_check", "fti", "mod_type", mod_type )
	end
end

--- Adds Base ---
function WeaponFactoryTweakData:akpack_check_adds( mod_type, mod_woa ) 
	if mod_type == "wpn" then
		if self[mod_woa] then
			self[mod_woa].adds = self[mod_woa].adds or {}
		else 
			self:akpack_write_error( "adds_check", "fti", mod_type, mod_woa )
		end
	elseif mod_type == "part" then
		if self.parts[mod_woa] then
			self.parts[mod_woa].adds = self.parts[mod_woa].adds or {}
		else 
			self:akpack_write_error( "adds_check", "fti", mod_type, mod_woa )
		end
	else
		self:akpack_write_error( "adds_check", "fti", "mod_type", mod_type )
	end
end

--- Part Copy Base ---
function WeaponFactoryTweakData:ak556_copy_part( att_og, att_cp )
    if self.parts[att_og] then
        self.parts[att_cp] = deep_clone(self.parts[att_og])
        self.parts[att_cp].pcs = {}
        self.parts[att_cp].is_a_unlockable = true
        table.insert(self.wpn_fps_ass_heffy_556.uses_parts, att_cp)
    else
        self:akpack_write_error( "copy_part", "fti", "part", att_og )    
    end
end

--- ERROR Base ---
function WeaponFactoryTweakData:akpack_write_error( func, cause, error_id, value  )
	if func and cause and error_id then 
		-- fti = failed to index
		if cause == "fti" and value then
			if error_id == "part" then
				log("AK74_ERROR: (" .. func .. ")Attempt to index Part ID: '" .. value .. "' (a nil value)")
			elseif error_id == "wpn" then
				log("AK74_ERROR: (" .. func .. ")Attempt to index Weapon ID: '" .. value .. "' (a nil value)")
			elseif error_id == "mod_type" then
				log("AK74_ERROR: (" .. func .. ")Attempt to index mod_type: '" .. value .. "' (a nil value)")
			end
		end
	end
end 

Hooks:PostHook( WeaponFactoryTweakData, "init", "AK74ModInit", function(self)

------------------------------------------
----<A><K><7><4> -Arrays- <A><K><7><4>----
------------------------------------------

--- Stocks ---
all_ak74stock = {
	"wpn_fps_ass_heffy_545_st_ak74",
	"wpn_fps_ass_heffy_545_st_aks74",
	"wpn_fps_ass_heffy_545_st_rpk74",
	"wpn_fps_ass_heffy_545_st_ak74m",
	"wpn_fps_ass_heffy_545_st_md86",
	"wpn_fps_ass_heffy_545_st_mpi"
}
--- Stock Pads ---
all_ak74stockpad = {
	"wpn_fps_ass_heffy_545_stp_ak74",
	"wpn_fps_ass_heffy_545_stp_ak74_2",
	"wpn_fps_ass_heffy_545_stp_rpk74",
	"wpn_fps_ass_heffy_545_str_rpk74",
	"wpn_fps_ass_heffy_545_stp_ak74m",
	"wpn_fps_ass_heffy_545_stp2_ak74m",
	"wpn_fps_ass_heffy_545_stp_md86",
	"wpn_fps_ass_heffy_545_stp_mpi"
}
ak74stockpad = {
	"wpn_fps_ass_heffy_545_stp_ak74",
	"wpn_fps_ass_heffy_545_stp_ak74_2",
	"wpn_fps_ass_heffy_545_stp_rpk74",
	"wpn_fps_ass_heffy_545_stp_md86",
	"wpn_fps_ass_heffy_545_stp_mpi"
}
--- Fore Grip ---
-- Default length --
all_ak74lfg = {
	"wpn_fps_ass_heffy_545_lfg_ak74",
	"wpn_fps_ass_heffy_545_lfg_rpk74",
	"wpn_fps_ass_heffy_545_lfg_ak74m",
	"wpn_fps_ass_heffy_545_lfg_mpi",
	"wpn_fps_ass_heffy_all_lfg_ak74"
}
all_ak74ufg = {
	"wpn_fps_ass_heffy_all_ufg_ak74",
	"wpn_fps_ass_heffy_545_ufg_ak74",
	"wpn_fps_ass_heffy_545_ufg_ak74m",
	"wpn_fps_ass_heffy_545_ufg_mpi",
	"wpn_fps_ass_heffy_545_ufg_tantal"
}
--- Barrel ---
-- Default length --
ak74barrel = {
	"wpn_fps_ass_heffy_545_ba_ak74",
	"wpn_fps_ass_heffy_545_ba_ak107"
}
all_ak74barrel = {
	"wpn_fps_ass_heffy_545_ba_ak74",
	"wpn_fps_ass_heffy_545_ba_rpk74",
	"wpn_fps_ass_heffy_545_ba_ak105",
	"wpn_fps_ass_heffy_545_ba_ak107",
	"wpn_fps_ass_heffy_545_ba_aks74u"
}

--- Front Sights ---
all_ak74fo = {
	"wpn_fps_ass_heffy_545_fo_ak74"
}

--- Rear Sights ---
all_ak74ro = {
	"wpn_fps_ass_heffy_545_ro_ak74",
	"wpn_fps_ass_heffy_545_ro_rpk74"
}

--- Barrel Extensions --
all_ak74ext = {
	"wpn_fps_upg_ns_ass_smg_large",
	"wpn_fps_upg_ns_ass_smg_medium",
	"wpn_fps_upg_ns_ass_smg_small",
	"wpn_fps_upg_ns_ass_smg_firepig",
	"wpn_fps_upg_ns_ass_smg_stubby",
	"wpn_fps_upg_ns_ass_smg_tank",
	"wpn_fps_upg_ns_ass_pbs1",
	"wpn_fps_upg_ass_ns_jprifles",
	"wpn_fps_upg_ass_ns_linear",
	"wpn_fps_upg_ass_ns_surefire",
	"wpn_fps_upg_ass_ns_battle",
	"wpn_fps_ass_heffy_545_fh_dummy",
	"wpn_fps_ass_heffy_545_fh_ak74",
	"wpn_fps_ass_heffy_545_fh_rpk74",
	"wpn_fps_ass_heffy_545_fh_ak105",
	"wpn_fps_ass_heffy_545_fh_ak107",
	"wpn_fps_ass_heffy_545_fh_tantal",
	"wpn_fps_ass_heffy_545_fh_aks74u"
}

--- Gadgets (Flashlights/Lasers) ---
all_ak74fl = {
	"wpn_fps_upg_fl_ass_smg_sho_peqbox",
	"wpn_fps_upg_fl_ass_smg_sho_surefire",
	"wpn_fps_upg_fl_ass_peq15",
	"wpn_fps_upg_fl_ass_laser",
	"wpn_fps_upg_fl_ass_utg",
	"wpn_fps_addon_ris"
}

--- Sights ---
all_ak74sight = {
	"wpn_fps_upg_o_specter",
	"wpn_fps_upg_o_aimpoint",
	"wpn_fps_upg_o_aimpoint_2",
	"wpn_fps_upg_o_docter",
	"wpn_fps_upg_o_eotech",
	"wpn_fps_upg_o_t1micro",
	"wpn_fps_upg_o_cmore",
	"wpn_fps_upg_o_acog",
	"wpn_fps_upg_o_cs",
	"wpn_fps_upg_o_eotech_xps",
	"wpn_fps_upg_o_reflex",
	"wpn_fps_upg_o_rx01",
	"wpn_fps_upg_o_rx30",
	"wpn_fps_upg_o_spot"
}
local vanilla_ak74sight = {
	"wpn_fps_upg_o_specter",
	"wpn_fps_upg_o_aimpoint",
	"wpn_fps_upg_o_aimpoint_2",
	"wpn_fps_upg_o_docter",
	"wpn_fps_upg_o_eotech",
	"wpn_fps_upg_o_t1micro",
	"wpn_fps_upg_o_cmore",
	"wpn_fps_upg_o_acog",
	"wpn_fps_upg_o_cs",
	"wpn_fps_upg_o_eotech_xps",
	"wpn_fps_upg_o_reflex",
	"wpn_fps_upg_o_rx01",
	"wpn_fps_upg_o_rx30",
	"wpn_fps_upg_o_spot"
}
--- Grips ---
all_ak74grips = {
	"wpn_fps_ass_heffy_545_pg_ak74",
	"wpn_fps_ass_heffy_545_pg_ak74m",
	"wpn_fps_ass_heffy_545_pg_mpi",
	"wpn_fps_ass_heffy_545_pg_74flat",
	"wpn_fps_ass_heffy_all_pg_ak74"
}

all_ak74bipod = {
	"wpn_fps_ass_heffy_545_bp_rpk74",
	"wpn_fps_ass_heffy_545_bp_rpk74_folded"
}


--- ARRAYS FOR OTHER MODULES ---

heffy545stocks = {
	"wpn_fps_ass_heffy_all_st_ak74",
	"wpn_fps_ass_heffy_545_st_rpk74",
	"wpn_fps_ass_heffy_545_st_mpi",
}
	
heffy545stockparts = {
	"wpn_fps_ass_heffy_545_stp_ak74",
	"wpn_fps_ass_heffy_545_stp_ak74_2",
	"wpn_fps_ass_heffy_545_stp_rpk74",
	"wpn_fps_ass_heffy_545_str_rpk74",
	"wpn_fps_ass_heffy_545_stp_mpi",
}
	

--- CAFCW aka better later then never also holy shit this actually works ---
if attach_tables then
	for _, md_id in pairs(attach_tables.Barrel_Extensions) do
		if self.parts[md_id] then
			table.insert(all_ak74ext, md_id)
		end
	end
	for _, md_id in pairs(attach_tables.Suppressors) do
		if self.parts[md_id] then
			table.insert(all_ak74ext, md_id)
		end
	end
	for _, fl_id in pairs(attach_tables.Gadgets) do
		if self.parts[fl_id] then
			table.insert(all_ak74fl, fl_id)
		end
	end
	for _, o_id in pairs(attach_tables.ACOG) do
		if self.parts[o_id] then
			table.insert(all_ak74sight, o_id)
		end
	end
	for _, o_id in pairs(attach_tables.Custom) do
		if self.parts[o_id] then
			table.insert(all_ak74sight, o_id)
		end
	end
	for _, o_id in pairs(attach_tables.Specter) do
		if self.parts[o_id] then
			table.insert(all_ak74sight, o_id)
		end
	end
	if attach_tables.Custom_AK then --safety (since that thing doesn't exist in older versions)
		for _, o_id in pairs(attach_tables.Custom_AK) do
			if self.parts[o_id] then
				table.insert(self.parts.wpn_fps_upg_o_ak74_l_scopemount.forbids, o_id)
			end
		end
	end
end


--- Compatibility Array Insertion ---

if self.wpn_fps_ass_heffy_762 then

	for id, part_id in pairs(heffy762stocks) do
		table.insert(all_ak74stock, part_id)
	end
		
	for id, part_id in pairs(heffy762stockparts) do
		table.insert(all_ak74stockpad, part_id)
		table.insert(ak74stockpad, part_id)
	end
		
	--- Forbids ---
	--Lower--
	for id, part_id in pairs(heffy762fgs) do
		self:akpack_setup_forbid( "wpn_fps_ass_heffy_545_lr_aks74u", part_id )
	end
	--VEPR--
	for _, pg_id in pairs(all_ak74grips) do
		if pg_id ~= "wpn_fps_ass_heffy_545_pg_ak74" then
			self:akpack_setup_forbid( "wpn_fps_ass_heffy_762_st_vepr", pg_id )
		end
	end
	
end

-----------------------------------------
----<A><K><7><4> -CAFCW- <A><K><7><4>----
-----------------------------------------

if BeardLib.Utils:FindMod("M82 Muzzle Brake") then
	table.insert(all_ak74ext, "wpn_fps_upg_ns_m82")
	table.insert(all_ak74ext, "wpn_fps_upg_ns_aw50")
end

if self.parts.wpn_fps_upg_o_thersig then
	table.insert(all_ak74sight, "wpn_fps_upg_o_thersig")
	table.insert(vanilla_ak74sight, "wpn_fps_upg_o_thersig")
end
--------------------------------------------
----<A><K><7><4> -Override- <A><K><7><4>----
--------------------------------------------

--- Gun ---

--- Barrel ---
for id, ba_id in pairs(all_ak74barrel) do
	self:akpack_check_override( "part", ba_id )
end
-- Default length barrel barrel extension and front sight override --
for id, ba_id in pairs(ak74barrel) do
	for id, ext_id in pairs(all_ak74ext) do
		if ext_id ~= "wpn_fps_ass_heffy_545_fh_dummy" then
			self.parts[ba_id].override[ext_id] = {a_obj = "a_ns"}
		end
	end
	for id, fo_id in pairs(all_ak74fo) do
		self.parts[ba_id].override[fo_id] = {}
	end
end

-- Other length barrel barrel extension overrides --
for id, ext_id in pairs(all_ak74ext) do
	if ext_id == "wpn_fps_ass_heffy_545_fh_dummy" then
		self.parts.wpn_fps_ass_heffy_545_ba_rpk74.override[ext_id]  = {a_obj = "a_ns_rpk", unit="units/mods/weapons/wpn_fps_ass_heffy_545_rpk74_pts/wpn_fps_ass_heffy_545_fh_rpk74"}
		self.parts.wpn_fps_ass_heffy_545_ba_aks74u.override[ext_id] = {a_obj = "a_ns_aks74u", unit="units/mods/weapons/wpn_fps_ass_heffy_545_aks74u_pts/wpn_fps_ass_heffy_545_fh_aks74u"}
		self.parts.wpn_fps_ass_heffy_545_ba_ak105.override[ext_id]  = {a_obj = "a_ns_ak105", unit="units/mods/weapons/wpn_fps_ass_heffy_545_ak105_pts/wpn_fps_ass_heffy_545_fh_ak105"}
	else
		self.parts.wpn_fps_ass_heffy_545_ba_ak105.override[ext_id]	= {a_obj = "a_ns_ak105"}
		self.parts.wpn_fps_ass_heffy_545_ba_aks74u.override[ext_id] = {a_obj = "a_ns_aks74u"}
		self.parts.wpn_fps_ass_heffy_545_ba_rpk74.override[ext_id] 	= {a_obj = "a_ns_rpk"}
	end
end
-- Other length barrel Front Sight overrides --
for id, fo_id in pairs(all_ak74fo) do
	self.parts.wpn_fps_ass_heffy_545_ba_ak105.override[fo_id]  = {unit  = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	self.parts.wpn_fps_ass_heffy_545_ba_aks74u.override[fo_id] = {a_obj = "a_fo_aks74u"}
	self.parts.wpn_fps_ass_heffy_545_ba_rpk74.override[fo_id]  = {a_obj = "a_fo_rpk"}
end

--- Fore Grip ---
-- Default length fg barrel position override --
-- Barrel position override by lfgs --
-- Front sight overrides by lfgs --
-- Barrel Extensions position override by lfgs --

--- Receiver aka Lower ---
self:akpack_check_override( "part", "wpn_fps_ass_heffy_545_lr_ak74m" )
self:akpack_check_override( "part", "wpn_fps_ass_heffy_545_lr_aks74u" )
self:akpack_check_override( "part", "wpn_fps_ass_heffy_545_lr_ak74" )
self:akpack_check_override( "part", "wpn_fps_ass_heffy_545_lr_rpk74" )

--compatibility override--
if self.wpn_fps_ass_heffy_762 then
	self.parts.wpn_fps_ass_heffy_545_lr_ak74m.override.wpn_fps_ass_heffy_all_st_ak47	= {a_obj="a_s_aks74u_ak47"}
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_all_st_ak47	= {a_obj="a_s_aks74u_ak47"}
	self.parts.wpn_fps_ass_heffy_545_lr_ak74.override.wpn_fps_ass_heffy_all_st_ak47 	= {a_obj="a_s_akm"}
	self.parts.wpn_fps_ass_heffy_545_lr_rpk74.override.wpn_fps_ass_heffy_all_st_ak47 	= {a_obj="a_s_akm"}
	self.parts.wpn_fps_ass_heffy_545_lr_ak74m.override.wpn_fps_ass_heffy_all_pg_ak47	= {a_obj="a_g_aks74u"}
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_all_pg_ak47	= {a_obj="a_g_aks74u"}
	self.parts.wpn_fps_ass_heffy_545_lr_ak74.override.wpn_fps_ass_heffy_all_pg_ak47 	= {a_obj="a_g_akm"}
	self.parts.wpn_fps_ass_heffy_545_lr_rpk74.override.wpn_fps_ass_heffy_all_pg_ak47 	= {a_obj="a_g_akm"}
end

--Stock overrides--
for id, st_id in pairs(all_ak74stock) do
	if st_id ~= "wpn_fps_ass_heffy_545_st_ak74m" and st_id ~= "wpn_fps_ass_heffy_545_st_aks74" then
		self.parts.wpn_fps_ass_heffy_545_lr_ak74m.override[st_id]  = {a_obj = "a_s_ak74m"}
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[st_id] = {a_obj = "a_s_aks74u"}
	end
end
--Stock Pad overrides--
for id, sp_id in pairs(ak74stockpad) do
	self.parts.wpn_fps_ass_heffy_545_lr_ak74m.override[sp_id]  = {a_obj = "a_s_ak74m"}
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[sp_id] = {a_obj = "a_s_aks74u"}
end
-- Barrel position override by lrs --
for id, ba_id in pairs(all_ak74barrel) do
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[ba_id] = {a_obj = "a_b_aks74u"}	
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[ba_id].override = self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[ba_id].override or {}
end
-- Front sight overrides by lrs --
for id, ba_id in pairs(ak74barrel) do
	for id, fo_id in pairs(all_ak74fo) do
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[ba_id].override[fo_id] = {a_obj = "a_fo_aks74u_std"}
	end
end
for id, fo_id in pairs(all_ak74fo) do
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_rpk74.override[fo_id]  = {a_obj = "a_fo_aks74u_rpk"}
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_ak105.override[fo_id]  = {a_obj = "a_fo_aks74u_ak105"}
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_aks74u.override[fo_id] = {a_obj = "a_fo_aks74u_aks74u"}
end
-- Barrel Extensions position override by lrs --
for id, ba_id in pairs(ak74barrel) do
	for id, ext_id in pairs(all_ak74ext) do
		if ext_id ~= "wpn_fps_ass_heffy_545_fh_dummy" then
			self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[ba_id].override[ext_id] = {a_obj = "a_ns_aks74u_std"}
		end
	end
end
self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_ak107.override.wpn_fps_ass_heffy_545_fh_dummy = {a_obj = "a_ns_aks74u_std", unit="units/mods/weapons/wpn_fps_ass_heffy_545_ak107_pts/wpn_fps_ass_heffy_545_fh_ak107"}
self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_ak74.override.wpn_fps_ass_heffy_545_fh_dummy  = {a_obj = "a_ns_aks74u_std", unit="units/mods/weapons/wpn_fps_ass_heffy_545_ak74_pts/wpn_fps_ass_heffy_545_fh_ak74"}

for id, ext_id in pairs(all_ak74ext) do
	if ext_id == "wpn_fps_ass_heffy_545_fh_dummy" then
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_aks74u.override[ext_id] = {a_obj = "a_ns_aks74u_aks74u", unit="units/mods/weapons/wpn_fps_ass_heffy_545_aks74u_pts/wpn_fps_ass_heffy_545_fh_aks74u"}
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_ak105.override[ext_id] = {a_obj = "a_ns_aks74u_ak105", unit="units/mods/weapons/wpn_fps_ass_heffy_545_ak105_pts/wpn_fps_ass_heffy_545_fh_ak105"}
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_rpk74.override[ext_id]   = {a_obj = "a_ns_aks74u_rpk", unit="units/mods/weapons/wpn_fps_ass_heffy_545_rpk74_pts/wpn_fps_ass_heffy_545_fh_rpk74"}
	else
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_rpk74.override[ext_id]   = {a_obj = "a_ns_aks74u_rpk"}
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_aks74u.override[ext_id] = {a_obj = "a_ns_aks74u_aks74u"}
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override.wpn_fps_ass_heffy_545_ba_ak105.override[ext_id] = {a_obj = "a_ns_aks74u_ak105"}
	end
end
-- Barrel Override --
--self.parts.wpn_fps_ass_heffy_545_ba_ak107.override.wpn_fps_ass_heffy_545_ro_aks74u = {a_obj="a_ro_ak107_aks74u"}
-- Scope override --
for id, o_id in pairs(all_ak74sight) do
	if o_id ~= "wpn_fps_upg_o_acog" then
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[o_id] = {a_obj = "a_o_aks74u", stance_mod = {wpn_fps_ass_heffy_545 = {translation = Vector3(0, 7, -2.8)}}}
	else
		self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[o_id] = {a_obj = "a_o_aks74u_acog", stance_mod = {wpn_fps_ass_heffy_545 = {translation = Vector3(0, 5, -2.8)}}}
	end
end
--- Magazines ---

--- Bipods ---
for id, bp_id in pairs(all_ak74bipod) do
	self.parts.wpn_fps_ass_heffy_545_lr_aks74u.override[bp_id] = {a_obj = "a_bp_aks74u"}
end
----------------------------------------
----<A><K><7><4> -Adds- <A><K><7><4>----
----------------------------------------
--- Gun ---
self:akpack_check_adds( "wpn", "wpn_fps_ass_heffy_545" )
for id, o_id in pairs(vanilla_ak74sight) do
	self.wpn_fps_ass_heffy_545.adds[o_id] = {"wpn_fps_upg_o_ak74_scopemount"}
end
	
-------------------------------------------
----<A><K><7><4> -Forbids- <A><K><7><4>----
-------------------------------------------

--- Pistol grips ---
-- AKM grips forbids --

--- Lower ---
for id, lfg_id in pairs(all_ak74lfg) do
	if lfg_id ~= "wpn_fps_ass_heffy_545_lfg_ak74" then
		self:akpack_setup_forbid( "wpn_fps_ass_heffy_545_lr_aks74u", lfg_id )
	end
end
for id, ufg_id in pairs(all_ak74ufg) do
	if ufg_id ~= "wpn_fps_ass_heffy_545_ufg_ak74" then
		self:akpack_setup_forbid( "wpn_fps_ass_heffy_545_lr_aks74u", ufg_id )
	end
end
self:akpack_setup_forbid( "wpn_fps_ass_heffy_545_lr_aks74u", "wpn_fps_upg_o_cs" )
----------
------------------------------------------
----<A><K><7><4> -Stance- <A><K><7><4>----
------------------------------------------

--- Vanilla sights ---
for id, o_id in pairs(vanilla_ak74sight) do
	if self.parts[o_id].stance_mod.wpn_fps_ass_flint then
		self.parts[o_id].stance_mod.wpn_fps_ass_heffy_545 = deep_clone(self.parts[o_id].stance_mod.wpn_fps_ass_flint)
	else
		log("[AK_Pack] [ERROR] WHO THE FUCK MESSED WITH SIGHT STANCES THIS TIME!? " .. o_id)
	end
end
-----------------------------------------------
----<A><K><7><4> -Underbarrel- <A><K><7><4>----
-----------------------------------------------


------------------------------------------
----<A><K><7><4> -Tweaks- <A><K><7><4>----
------------------------------------------

--- Barrel Extensions ---
self.parts.wpn_fps_ass_heffy_545_fh_dummy.pcs = nil

------------------------------------------
----<A><K><7><4> -CLONES- <A><K><7><4>----
------------------------------------------

self:akpack_check_override( "wpn", "wpn_fps_ass_heffy_545" )


---------------------------------------
----<A><K><7><4> -WIP- <A><K><7><4>----
---------------------------------------

---- Override ----


--- Gadget positions ---
--[[ 
for id, part_id in pairs(all_ak47fl) do
	self.parts.wpn_fps_ass_heffy_545_flp_<insert_flashlight_position_name>.override[part_id] = {a_obj = "a_fl_ak47"}
end
--]]



------------------------------------------------------
----<A><K><7><4> -Other modules code- <A><K><7><4>----
------------------------------------------------------
---- AK-9 ----
if self.wpn_fps_ass_heffy_939 then

	for i, part_id in pairs(heffy545stocks) do
		self.parts.wpn_fps_ass_heffy_939_lr_ak9.override[part_id] = {a_obj="a_s_akmsu"}
	end
	
	for i, part_id in pairs(heffy545stockparts) do
		self.parts.wpn_fps_ass_heffy_939_lr_ak9.override[part_id] = {a_obj="a_s_akmsu"}
	end
	
end
---- AK-101 ----
if self.wpn_fps_ass_heffy_556 then
	for id, part_id in pairs(heffy545stocks) do
		self.parts.wpn_fps_ass_heffy_556_lr_ak101.override[part_id] = {a_obj="a_s_akmsu"}
	end
	
	for id, part_id in pairs(heffy545stockparts) do
		self.parts.wpn_fps_ass_heffy_556_lr_ak101.override[part_id] = {a_obj="a_s_akmsu"}
	end
	
end

end )

